#ifndef IO_H
#define IO_H

#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <vector>
#include <list>
#include <math.h>
#include <iomanip>
#include "trappack.h"
using namespace std;

void readInputFile(ifstream &inStream);
//Reads the input file and calculates the lower bound tMin

void printStock(vector<PIECE> &S);
//Prints a stock to the screen

void prettyPrintSolution(vector<vector<PIECE> > candSol, vector<long> stockUsage);
//Just prints the solution to the screen

void prettyPrintPopulation(vector<vector<vector<PIECE> > > &pop, vector<vector<long> > popStockUsage);
//Prints a whole population of solutions to the screen

void prettyPrintSolutionProj(vector<vector<PIECE> > candSol, vector<long> stockUsage);
//Prints solution to the screen, just the projections

void prettyPrintByType(vector<vector<int> > candSol, vector<long> stockUsage);
void prettyPrintByType(vector<vector<PIECE> > candSol, vector<long> stockUsage);

void prettyPrintOutputSolution(vector<vector<PIECE> > candSol, vector<long> stockUsage);
//Prints solution in solution file format for visualiser

void checkSolution(vector<vector<PIECE> > &candSol, vector<long> &stockUsage);
//Takes a complete solution and checks that it represents a feasible packing.
//Returns error messages if it is wrong/illegal

#endif //IO_H
