#ifndef TRAPPACK_H
#define TRAPPACK_H

// The following two statements stop the compiler producing the following: "warning C4018: '<' : signed/unsigned mismatch". Can be deleted with no effect.
#pragma warning(disable: 4018)
#pragma warning(disable: 4267)

#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <set>
#include <vector>
#include <algorithm>
#include <list>
#include <time.h>
#include <math.h>

//Define the information kept on each shape
struct SHAPE {  
   int len;			//Total length of the object
   int p1;			//left hand projection
   int p2;			//right hand projection
   int centralLen;	//Length of bit without projections
   long area;		//Area of the shape
   int parallelogram; //0=Trapezoid; 1=Parrallelogram
   int shapeNum;	//If the file had diff objects of the same shape then we could use this
};

struct TYPE {  
   int numOccurences;//Number of occurences of the shape type in the problem instance
   int firstIndex;   //First index of each type
   int len;			 //Total length of the object
   int p1;			 //left hand projection
   int p2;			 //right hand projection
   int centralLen;	 //Length of bit without projections
   long area;		 //Area of the shape
   int parallelogram; //0=Trapezoid; 1=Parrallelogram
};

//Define the information kept on each shape when it is in a stock
struct PIECE {
	int num;
	bool LtoR;
};

#include "fns.h"
#include "io.h"
#include "packshapes.h"
#include "hillclimber.h"
#include "GA.h"
#include "diversity.h"

#endif //TRAPPACK


